//
//  wbiff! mailbox flag for Windows
//	Copyright  1999, 2000 F. Sadaghiani (sada@guesswork.org)
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 
//
//  59 Temple Place - Suite 330
//  Boston, MA 
//  02111-1307, USA.
//
//

#pragma once

bool
mail_general_SendSingleLine(SOCKET hSocket, LPTSTR lpBuffer, int nLength);

bool
mail_general_ReceiveSingleLine(SOCKET hSocket, LPTSTR lpBuffer, int nLength);

int
mail_general_GetHostAddress(LPTSTR lpHostName, struct in_addr* addr);

int
mail_general_ConnectTo(const MAIL_PACCOUNT pAccount);

int 
mail_general_Startup(void);

void 
mail_general_Cleanup(void);

/////////////////////////////////////////////////////////////////////////////
//
// Headers Functions

void
mail_general_FreeAccount(MAIL_PACCOUNT pAccount);

bool
mail_general_AllocMessages(MAIL_PACCOUNT pAccount);

void
mail_general_FreeAllAccounts(MAIL_PACCOUNT pAccounts, int nCount);


#define ERROR_CODES_START -100

typedef enum errorCodes {

	errorBadLogon = ERROR_CODES_START,
	errorConnectionTimedout,
	errorSendRecvTimedout,
	errorUnableToConnect,

	// imap4 specified
	errorImap4_SelectError,
	errorImap4_CheckError,
	errorImap4_SearchError,

	// pop3 specified
	errorPop3_StatError,
	errorPop3_TopError,
};


LPCTSTR mail_general_GetErrorMessageFromCode(int error);
