//
//  wbiff! mailbox flag for Windows
//	Copyright  1999, 2000 F. Sadaghiani (sada@guesswork.org)
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 
//
//  59 Temple Place - Suite 330
//  Boston, MA 
//  02111-1307, USA.
//
//

#include "std_wb.h"
#include "reg.h"

// one-call registry wrappers

bool // read an integer
regRI(HKEY hKey, BYTE* val, LPTSTR key)
{
	DWORD type, size;

	type = REG_DWORD;
	size = sizeof(DWORD);
	return RegQueryValueEx(hKey, key, NULL, &type, val, &size) == ERROR_SUCCESS;
}

void // read a string
regRS(HKEY hKey, LPTSTR buffer, int nLength, LPTSTR key)
{
	DWORD type;

	type = REG_SZ;
	buffer[0] = _T('\0');
	RegQueryValueEx(hKey, key, NULL, &type, (BYTE*) buffer, &nLength);
}

void // write an integer
regWI(HKEY hKey, BYTE* val, LPTSTR key)
{
	RegSetValueEx(hKey, key, 0, REG_DWORD, val, sizeof(DWORD));
}

void // write a string
regWS(HKEY hKey, LPCTSTR val, LPTSTR key)
{
	RegSetValueEx(hKey, key, 0, REG_SZ, (const BYTE*) val, lstrlen(val) + 1);
}
