//
//  wbiff! mailbox flag for Windows
//	Copyright  1999, 2000 F. Sadaghiani (sada@guesswork.org)
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 
//
//  59 Temple Place - Suite 330
//  Boston, MA 
//  02111-1307, USA.
//
//

#pragma once

/////////////////////////////////////////////////////////////////////////////
//
// Structures

typedef struct tagSKIN
{
	// Skin definition
	TCHAR Image[MAX_PATH + 1];
	TCHAR Name[64];
	TCHAR HyperLinkText[64];
	TCHAR HyperLink[128];
	TCHAR Icon_FlagDown[MAX_PATH + 1];
	TCHAR Icon_FlagDownDisabled[MAX_PATH + 1];
	TCHAR Icon_FlagUp[MAX_PATH + 1];
	TCHAR Icon_Broken[MAX_PATH + 1];
	TCHAR FontFaceName[32];
	COLORREF FontColor;

	// Window definition
	int Width;
	int Height;

	RECT FontRect;
	RECT FlagRect;
	RECT SysButtonRect;
	RECT MinButtonRect;
	RECT ClsButtonRect;
	RECT CaptionRect;

	// Bitmap definition
	int Window_X;
	int Window_Y;
	
	int FlagDown_X;
	int FlagDown_Y;
	
	int FlagUp_X;
	int FlagUp_Y;
	
	int SysButtonDown_X;
	int SysButtonDown_Y;
	
	int SysButtonUp_X;
	int SysButtonUp_Y;
	
	int MinButtonDown_X;
	int MinButtonDown_Y;
	
	int MinButtonUp_X;
	int MinButtonUp_Y;
	
	int ClsButtonDown_X;
	int ClsButtonDown_Y;
	
	int ClsButtonUp_X;
	int ClsButtonUp_Y;

//--------------->

	// handles to objects that are created based on the
	// above variables

	HFONT hFont;
	HBITMAP hBitmap;
	HRGN hRegion;
	HICON hIconFlagUp;
	HICON hIconFlagDown;
	HICON hIconFlagDownDisabled;
	HICON hIconBroken;

//--------------->

} SKIN, *PSKIN;

/////////////////////////////////////////////////////////////////////////////
//
// Interface

bool 
skin_Load(PSKIN s, LPCTSTR skinfile);

HRGN 
skin_BitmapToRegion(HBITMAP hBmp, COLORREF cTransparentColor, COLORREF cTolerance, int xoffset, int yoffset);







