//
//  wbiff! mailbox flag for Windows
//	Copyright  1999, 2000 F. Sadaghiani (sada@guesswork.org)
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 
//
//  59 Temple Place - Suite 330
//  Boston, MA 
//  02111-1307, USA.
//
//

#include "std_wb.h"
#include "types.h"

#include "stats.h"

#include "reg.h"

#pragma intrinsic(memset)
#pragma hdrstop

void
stats_Load(PSTATS pStats)
{
	HKEY hKey;

	ZeroMemory(pStats, sizeof(STATS));
	if (RegOpenKeyEx(HKEY_CURRENT_USER, _T("Software\\wbiff!"), 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS) {

		REGRI(hKey, pStats->nMessages, _T("stats_nMessages"), 0)
		REGRI(hKey, pStats->nTimesLoaded, _T("stats_nTimesLoaded"), 0)
		REGRI(hKey, pStats->nTimesChecked, _T("stats_nTimesChecked"), 0)

		{
			DWORD type = REG_BINARY;
			DWORD size = sizeof(SYSTEMTIME);
			PVOID data = (PVOID)&(pStats->stFirstRun);

			if (RegQueryValueEx(hKey, _T("stats_stFirstRun"), NULL, &type, (LPBYTE) data, &size) != ERROR_SUCCESS) {

				GetLocalTime(&pStats->stFirstRun);
			}
		}

		++pStats->nTimesLoaded;

		RegCloseKey(hKey);
	}
}

void
stats_Save(PSTATS pStats)
{
	HKEY hKey;

	if (RegOpenKeyEx(HKEY_CURRENT_USER, _T("Software\\wbiff!"), 0, KEY_ALL_ACCESS, &hKey) == ERROR_SUCCESS) {

		regWI(hKey, (LPBYTE) &pStats->nMessages, _T("stats_nMessages"));
		regWI(hKey, (LPBYTE) &pStats->nTimesLoaded, _T("stats_nTimesLoaded"));
		regWI(hKey, (LPBYTE) &pStats->nTimesChecked, _T("stats_nTimesChecked"));
		RegSetValueEx(hKey, _T("stats_stFirstRun"), 0, REG_BINARY, (LPBYTE) &pStats->stFirstRun, sizeof(SYSTEMTIME));
		RegCloseKey(hKey);
	}
}



