//
//  wbiff! mailbox flag for Windows
//	Copyright  1999, 2000 F. Sadaghiani (sada@guesswork.org)
// 
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//  
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 
//
//  59 Temple Place - Suite 330
//  Boston, MA 
//  02111-1307, USA.
//
//

/*
TODO
----
*/


#include "std_wb.h"

#include "tracelog.h"

#pragma hdrstop
#pragma intrinsic(memset,memcpy)

#ifdef TRACE_ENABLE

static HANDLE hDumpFile = NULL;

void
tracelog_Print(LPCTSTR lpFormat, ...)
{
	TCHAR buffer[1024];
	TCHAR tbuffer[256];
	DWORD b;
	va_list args;

	ASSERT(hDumpFile != NULL);

	GetTimeFormat(LOCALE_USER_DEFAULT, LOCALE_NOUSEROVERRIDE, NULL, NULL, tbuffer, sizeof(tbuffer));
	
	va_start(args, lpFormat);
	wvsprintf(buffer, lpFormat, args);
	va_end(args);

	WriteFile(hDumpFile, tbuffer, lstrlen(tbuffer), &b, NULL);
	WriteFile(hDumpFile, " - ", 3, &b, NULL);
	WriteFile(hDumpFile, buffer, lstrlen(buffer), &b, NULL);

#ifdef _DEBUG
	OutputDebugString(buffer);
#endif
}

void
tracelog_Open(LPCTSTR lpFileName)
{
	TCHAR dbuffer[256];

	ASSERT(hDumpFile == NULL);
	GetDateFormat(LOCALE_USER_DEFAULT, LOCALE_NOUSEROVERRIDE, NULL, NULL, dbuffer, sizeof(dbuffer));
	hDumpFile = CreateFile(lpFileName, GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	SetFilePointer(hDumpFile, 0, NULL, FILE_END);
	tracelog_Print("TRACE log file opened on %s\r\n", dbuffer);
}

void
tracelog_Close(void)
{
	TCHAR dbuffer[256];

	ASSERT(hDumpFile != NULL);
	GetDateFormat(LOCALE_USER_DEFAULT, LOCALE_NOUSEROVERRIDE, NULL, NULL, dbuffer, sizeof(dbuffer));
	tracelog_Print("TRACE log file closed on %s\r\n\r\n\r\n\r\n", dbuffer);
	CloseHandle(hDumpFile);
}

#endif

